diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/net.c
--- a/src/dep/net.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/net.c	Sun Oct 27 22:49:29 2013 -0700
@@ -545,111 +867,256 @@
 		PERROR("failed to call SO_BINDTODEVICE on the interface");
 		return FALSE;
 	}
+#endif  /* linux */
+#endif  /* USE_BINDTODEVICE */
+
+
+  /* send a uni-cast address if specified (useful for testing) */
+  if (rtOpts->unicastAddress[0]) {
+    /* Attempt a DNS lookup first. */
+    struct hostent *host;
+#ifdef __sun
+    host = gethostbyname(rtOpts->unicastAddress);
+#else
+    host = gethostbyname2(rtOpts->unicastAddress, AF_INET);
 #endif
-#endif
-
-
-	/* send a uni-cast address if specified (useful for testing) */
-	if (rtOpts->unicastAddress[0]) {
-		/* Attempt a DNS lookup first. */
-		struct hostent *host;
-		host = gethostbyname2(rtOpts->unicastAddress, AF_INET);
-                if (host != NULL) {
-			if (host->h_length != 4) {
-				PERROR("unicast host resolved to non ipv4"
-				       "address");
-				return FALSE;
-			}
-			netPath->unicastAddr = 
-				*(uint32_t *)host->h_addr_list[0];
-		} else {
-			/* Maybe it's a dotted quad. */
-			if (!inet_aton(rtOpts->unicastAddress, &netAddr)) {
-				ERROR("failed to encode uni-cast address: %s\n",
-				      rtOpts->unicastAddress);
-				return FALSE;
-				netPath->unicastAddr = netAddr.s_addr;
-			}
-                }
-	} else {
-                netPath->unicastAddr = 0;
-	}
+    if (host != NULL) {
+      if (host->h_length != 4) {
+        PERROR("unicast host resolved to non ipv4"
+              "address");
+        return FALSE;
+      }
+      netPath->unicastAddr =
+	      *(uint32_t *)host->h_addr_list[0];
+    } else {
+      /* Maybe it's a dotted quad. */
+      if (!inet_aton(rtOpts->unicastAddress, &netAddr)) {
+        ERROR("failed to encode uni-cast address: %s\n",
+              rtOpts->unicastAddress);
+        return FALSE;
+        netPath->unicastAddr = netAddr.s_addr;
+      }
+    }
+  } else {
+    netPath->unicastAddr = 0;
+  }
 
 	/* init UDP Multicast on both Default and Pear addresses */
 	if (!netInitMulticast(netPath, rtOpts)) {
 		return FALSE;
 	}
 
-	/* set socket time-to-live to 1 */
+  /* set socket time-to-live to 1 */
 
-	if (setsockopt(netPath->eventSock, IPPROTO_IP, IP_MULTICAST_TTL, 
-		       &rtOpts->ttl, sizeof(int)) < 0
-	    || setsockopt(netPath->generalSock, IPPROTO_IP, IP_MULTICAST_TTL, 
-			  &rtOpts->ttl, sizeof(int)) < 0) {
-		PERROR("failed to set the multi-cast time-to-live");
-		return FALSE;
-	}
+  if (setsockopt(netPath->eventSock, IPPROTO_IP, IP_MULTICAST_TTL,
+          &rtOpts->ttl, sizeof(rtOpts->ttl)) < 0
+      || setsockopt(netPath->generalSock, IPPROTO_IP, IP_MULTICAST_TTL,
+        &rtOpts->ttl, sizeof(rtOpts->ttl)) < 0) {
+    PERROR("failed to set the multi-cast time-to-live");
+    return FALSE;
+  }
 
-	/* enable loopback */
-	temp = 1;
+#ifndef __sun
+  /* enable loopback */
+  temp = useSystemTimeStamps;
 
 	DBG("Going to set IP_MULTICAST_LOOP with %d \n", temp);
 
-	if (setsockopt(netPath->eventSock, IPPROTO_IP, IP_MULTICAST_LOOP, 
-		       &temp, sizeof(int)) < 0
-	    || setsockopt(netPath->generalSock, IPPROTO_IP, IP_MULTICAST_LOOP, 
-			  &temp, sizeof(int)) < 0) {
-		PERROR("failed to enable multi-cast loopback");
-		return FALSE;
-	}
+  if (setsockopt(netPath->eventSock, IPPROTO_IP, IP_MULTICAST_LOOP,
+          &temp, sizeof(int)) < 0
+      || setsockopt(netPath->generalSock, IPPROTO_IP, IP_MULTICAST_LOOP,
+        &temp, sizeof(int)) < 0) {
+    PERROR("failed to enable multi-cast loopback");
+    return FALSE;
+  }
+#else
+  /* enable loopback */
+  /* On Solaris, the IP_MULTICAST_LOOP takes uchar_t as data */
+  temp_char = useSystemTimeStamps;
+	
+  DBG("Going to set IP_MULTICAST_LOOP with %d \n", temp);
+
+  if (setsockopt(netPath->eventSock, IPPROTO_IP, IP_MULTICAST_LOOP,
+          &temp_char, sizeof(temp_char)) < 0
+      || setsockopt(netPath->generalSock, IPPROTO_IP, IP_MULTICAST_LOOP,
+        &temp_char, sizeof(temp_char)) < 0) {
+    PERROR("failed to enable multi-cast loopback");
+    return FALSE;
+  }
+#endif
+
+#ifdef __sun
+  /* Open a socket for hw assist IOCTLs only if we need it */
+  if (rtOpts->time_mode == TIME_BOTH || rtOpts->time_mode == TIME_NIC) {
+       /*
+        * On Solaris, we cannot use netPath->eventSock to send ioctl to 
+        * NIC driver as eventSock is a datagram socket. In the plumbed
+        * network stack, ip module act as a driver which means ip will
+        * not pass unknown ioctl down. So, we create a new fd to be
+        * used for ioctls to NIC.
+        */
+       snprintf(devpath, sizeof(devpath), "/dev/net/%s", rtOpts->ifaceName); 
+       if ((netPath->devFd = open(devpath, O_RDWR)) < 0) {
+               PERROR("failed to open device %s\n", devpath);
+               return FALSE;
+       } else {
+               DBG("open()ed %s\n", devpath);
+       }
+  }
+
+#endif
 
 	/* make timestamps available through recvmsg() */
-	if (!netInitTimestamping(netPath)) {
+	if (!netInitTimestamping(netPath, useSystemTimeStamps)) {
 		ERROR("failed to enable receive time stamps");
 		return FALSE;
 	}
 
-	return TRUE;
+  return TRUE;
 }
 
 /*Check if data have been received*/
-int 
+int
 netSelect(TimeInternal * timeout, NetPath * netPath)
 {
-	int ret, nfds;
-	fd_set readfds;
-	struct timeval tv, *tv_ptr;
+  int ret, nfds;
+  fd_set readfds;
+  struct timespec tv;
+  const struct timespec *tv_ptr;
+  sigset_t ignore_sigs;
 
-	if (timeout < 0)
-		return FALSE;
+  if (netPath->tx_stack.count)
+    return TRUE;
 
-	FD_ZERO(&readfds);
-	FD_SET(netPath->eventSock, &readfds);
-	FD_SET(netPath->generalSock, &readfds);
+  FD_ZERO(&readfds);
+  FD_SET(netPath->eventSock, &readfds);
+  FD_SET(netPath->generalSock, &readfds);
 
-	if (timeout) {
-		tv.tv_sec = timeout->seconds;
-		tv.tv_usec = timeout->nanoseconds / 1000;
-		tv_ptr = &tv;
-	} else
-		tv_ptr = 0;
+  if (timeout) {
+    tv.tv_sec = timeout->seconds;
+    tv.tv_nsec = timeout->nanoseconds;
+    tv_ptr = &tv;
+  } else
+    tv_ptr = 0;
 
-	if (netPath->eventSock > netPath->generalSock)
-		nfds = netPath->eventSock;
-	else
-		nfds = netPath->generalSock;
+  if (netPath->eventSock > netPath->generalSock)
+    nfds = netPath->eventSock;
+  else
+    nfds = netPath->generalSock;
 
-	ret = select(nfds + 1, &readfds, 0, 0, tv_ptr) > 0;
+  ret = pselect(nfds + 1, &readfds, 0, 0, tv_ptr, &ignore_sigs) > 0;
 
-	if (ret < 0) {
-		if (errno == EAGAIN || errno == EINTR)
-			return 0;
-	}
-	return ret;
+  if (ret < 0) {
+    if (errno == EAGAIN || errno == EINTR)
+      return 0;
+  }
+  return ret;
 }
 
+#ifdef linux
+/* Used to get receive timestamps when in the SYSTEM  LINUX_HW or LINUX_SW time modes */
+static int do_rx_timestamping(struct msghdr *msg, TimeInternal *time, RunTimeOpts *rtOpts)
+{
+    struct cmsghdr *cm;
+    struct timeval *tv;
+    Boolean have_time = FALSE;
 
+    /* @ioctl_timestamping As v1 code, added bool to break out of loop on discovery for ts. */
+    for (cm = CMSG_FIRSTHDR(msg); !have_time && cm != NULL; cm = CMSG_NXTHDR(msg, cm)) {
 
+        struct timespec *stamp;
+
+        DUMP("CM", cm, cm->cmsg_len);
+
+        if (cm->cmsg_level != SOL_SOCKET)
+            continue;
+
+        switch (cm->cmsg_type) {
+
+        case SCM_TIMESTAMP:
+            tv = (struct timeval *)CMSG_DATA(cm);
+            if(cm->cmsg_len < sizeof(*tv))
+            {
+                ERROR("received short SCM_TIMESTAMP (%d/%d)\n",
+                      cm->cmsg_len, sizeof(*tv));
+                return -1;
+            }
+
+            time->seconds = tv->tv_sec;
+            time->nanoseconds = tv->tv_usec*1000;
+            have_time = TRUE;
+            break;
+
+#ifdef SO_TIMESTAMPNS
+        case SCM_TIMESTAMPNS:
+            stamp = (struct timespec *)CMSG_DATA(cm);
+            if(cm->cmsg_len < sizeof(*stamp))
+            {
+                ERROR("received short SCM_TIMESTAMPNS (%d/%d)\n",
+                      cm->cmsg_len, sizeof(*stamp));
+                return -1;
+            }
+            time->seconds = stamp->tv_sec;
+            time->nanoseconds = stamp->tv_nsec;
+            have_time = TRUE;
+            break;
+#endif
+
+        case SO_TIMESTAMPING:
+        {
+            const char *ts_text;
+
+            /* array of three time stamps: software, HW, raw HW */
+            stamp = (struct timespec*)CMSG_DATA(cm);
+
+            if (cm->cmsg_len < sizeof(*stamp)*3) {
+                ERROR("received short SO_TIMESTAMPING (%d/%d)\n",
+                cm->cmsg_len, (int)sizeof(*stamp)*3);
+                return -1;
+            }
+
+            switch (rtOpts->time_mode) {
+                case TIME_SYSTEM_LINUX_SW:
+                    /* Desired timestamp is first in array */
+                    ts_text = "SW SYS";
+                    break;
+                case TIME_SYSTEM_LINUX_HW:
+                    /* Desired timestamp is second in array */
+                    ts_text = "HW SYS";
+                    stamp++;
+                    break;
+                case TIME_NIC:
+                case TIME_BOTH:
+                    /* Desired timestamp is third in array */
+                    ts_text = "HW RAW";
+                    stamp += 2;
+                    break;
+                default:
+                    ERROR("Invalid case in switch %d\n", rtOpts->time_mode);
+                    break;
+            }
+
+            if (stamp->tv_sec && stamp->tv_nsec) {
+                DBG2("%s Rx TIMESTAMP %d.%09d\n", ts_text, stamp->tv_sec, stamp->tv_nsec);
+                time->seconds = stamp->tv_sec;
+                time->nanoseconds = stamp->tv_nsec;
+
+                have_time = TRUE;
+            }
+        }
+            break;
+        }
+    }
+
+    if (!have_time) {
+        DBG("no receive time stamp\n");
+        return -1;
+    }
+    DBG("kernel recv time stamp %us %dns\n", time->seconds, time->nanoseconds);
+
+    return 0;
+}
+#endif /* linux */
 
 /** 
  * store received data from network to "buf" , get and store the
@@ -668,16 +1135,17 @@
  */
 
 ssize_t 
-netRecvEvent(Octet * buf, TimeInternal * time, NetPath * netPath)
+netRecvEvent(Octet * buf, TimeInternal * time, PtpClock *ptpClock, RunTimeOpts *rtOpts, Boolean *loopedBackTx)
 {
 	ssize_t ret;
 	struct msghdr msg;
 	struct iovec vec[1];
 	struct sockaddr_in from_addr;
+	NetPath *netPath = &ptpClock->netPath;
 
 	union {
 		struct cmsghdr cm;
-		char	control[CMSG_SPACE(sizeof(struct timeval))];
+		char	control[512];
 	}     cmsg_un;
 
 	struct cmsghdr *cmsg;
@@ -690,10 +1158,25 @@
 #endif
 	
 #if defined(SO_TIMESTAMP)
-	struct timeval * tv;
+	struct timeval tv;
+	struct timeval * tv1;
 #endif
 	Boolean timestampValid = FALSE;
 
+  /* Pop packet from stack. */
+  if (netPath->tx_stack.count) {
+    int index = netPath->tx_stack.count - 1;
+    ret = netPath->tx_stack.data[index].len;
+    memcpy(buf, netPath->tx_stack.data[index].buf, ret);
+    time->seconds = netPath->tx_stack.data[index].ts.seconds;
+    time->nanoseconds = netPath->tx_stack.data[index].ts.nanoseconds;
+    netPath->tx_stack.count--;
+    DBGV("netRecvEvent: ts from stack %d bytes\n", ret);
+    *loopedBackTx = TRUE;
+    return ret;
+  }
+
+	*loopedBackTx = FALSE;
 
 	vec[0].iov_base = buf;
 	vec[0].iov_len = PACKET_SIZE;
@@ -735,10 +1218,19 @@
 	netPath->lastRecvAddr = from_addr.sin_addr.s_addr;
 #endif
 
+  /* If we are collecting timestamps using the driver IOCTL method, we
+   * need to wait until we've decoded the header before processing the
+   * timestamps. For other methods, call do_rx_timestamping().
+   */
+  if (ptpClock->tsMethod == TS_METHOD_DRIVER_IOCTL) {
+    return ret;
+  }
 
-
+#ifdef linux
+  return (do_rx_timestamping(&msg, time, rtOpts) == 0)? ret: 0;
+#else
 	if (msg.msg_controllen <= 0) {
-		ERROR("received short ancillary data (%ld/%ld)\n",
+		ERROR("netRecvEvent: received short ancillary data (%ld/%ld)\n",
 		    (long)msg.msg_controllen, (long)sizeof(cmsg_un.control));
 
 		return 0;
@@ -772,9 +1264,16 @@
 			
 #if defined(SO_TIMESTAMP)
 			if(cmsg->cmsg_type == SCM_TIMESTAMP) {
-				tv = (struct timeval *)CMSG_DATA(cmsg);
-				time->seconds = tv->tv_sec;
-				time->nanoseconds = tv->tv_usec * 1000;
+				tv1 = (struct timeval *)CMSG_DATA(cmsg);
+				/*
+				 * tv->sec is 8 byte field, 
+				 * tv may not be 8 byte aligned.
+				 * Use memcpy();
+				 *
+				 */
+				memcpy(&tv, tv1, sizeof(struct timeval));
+				time->seconds = tv.tv_sec;
+				time->nanoseconds = tv.tv_usec * 1000;
 				timestampValid = TRUE;
 				DBGV("kernel MICRO recv time stamp %us %dns\n",
 				     time->seconds, time->nanoseconds);
@@ -795,6 +1294,7 @@
 	}
 
 	return ret;
+#endif /* ifdef linux */
 }
 
 
@@ -811,13 +1311,34 @@
  * @return 
  */
 
+ssize_t
+netRecvGeneral_old(Octet * buf, TimeInternal * time, NetPath * netPath)
+{
+  ssize_t ret;
+  struct sockaddr_in from_addr;
+  socklen_t addr_len = sizeof(struct sockaddr_in);
+
+  ret = recvfrom(netPath->generalSock, buf, PACKET_SIZE, MSG_DONTWAIT,
+          (struct sockaddr *)&from_addr, &addr_len);
+  if (ret <= 0) {
+    if (errno == EAGAIN || errno == EINTR)
+      return 0;
+
+    return ret;
+  }
+
+  DBGV("netRecvGeneral: rxed %d bytes\n", ret);
+  return ret;
+}
+
 ssize_t 
-netRecvGeneral(Octet * buf, TimeInternal * time, NetPath * netPath)
+netRecvGeneral(Octet * buf, TimeInternal * time,  PtpClock *ptpClock, RunTimeOpts *rtOpts)
 {
 	ssize_t ret;
 	struct msghdr msg;
 	struct iovec vec[1];
 	struct sockaddr_in from_addr;
+	NetPath *netPath = &ptpClock->netPath;
 	
 	union {
 		struct cmsghdr cm;
@@ -825,7 +1346,7 @@
 	}     cmsg_un;
 	
 	struct cmsghdr *cmsg;
-	
+
 #if defined(SO_TIMESTAMPNS)
 	struct timespec * ts;
 #elif defined(SO_BINTIME)
@@ -834,7 +1355,8 @@
 #endif
 	
 #if defined(SO_TIMESTAMP)
-	struct timeval * tv;
+	struct timeval tv;
+	struct timeval * tv1;
 #endif
 	Boolean timestampValid = FALSE;
 	
@@ -880,11 +1402,18 @@
 #ifdef PTP_EXPERIMENTAL
 	netPath->lastRecvAddr = from_addr.sin_addr.s_addr;
 #endif
-	
+
+  /* If we are collecting timestamps using the driver IOCTL method, we
+   * need to wait until we've decoded the header before processing the
+   * timestamps. For other methods, call do_rx_timestamping().
+   */
+  if (ptpClock->tsMethod == TS_METHOD_DRIVER_IOCTL) {
+    return ret;
+  }
 	
 	
 	if (msg.msg_controllen <= 0) {
-		ERROR("received short ancillary data (%ld/%ld)\n",
+		ERROR("netRecvGeneral : received short ancillary data (%ld/%ld)\n",
 		      (long)msg.msg_controllen, (long)sizeof(cmsg_un.control));
 		
 		return 0;
@@ -918,9 +1447,10 @@
 			
 #if defined(SO_TIMESTAMP)
 			if(cmsg->cmsg_type == SCM_TIMESTAMP) {
-				tv = (struct timeval *)CMSG_DATA(cmsg);
-				time->seconds = tv->tv_sec;
-				time->nanoseconds = tv->tv_usec * 1000;
+				tv1 = (struct timeval *)CMSG_DATA(cmsg);
+				memcpy(&tv, tv1, sizeof (struct timeval));
+				time->seconds = tv.tv_sec;
+				time->nanoseconds = tv.tv_usec * 1000;
 				timestampValid = TRUE;
 				DBGV("kernel MICRO recv time stamp %us %dns\n",
 				     time->seconds, time->nanoseconds);
@@ -955,11 +1485,12 @@
 ///
 /// TODO: merge these 2 functions into one
 ///
-ssize_t 
-netSendEvent(Octet * buf, UInteger16 length, NetPath * netPath, Integer32 alt_dst)
+int
+netSendEvent(Octet * buf, UInteger16 length, PtpClock *ptpClock, RunTimeOpts *rtOpts, Integer32 alt_dst)
 {
-	ssize_t ret;
+	int ret;
 	struct sockaddr_in addr;
+	NetPath *netPath = &ptpClock->netPath;
 
 	addr.sin_family = AF_INET;
 	addr.sin_port = htons(PTP_EVENT_PORT);
@@ -971,75 +1502,71 @@
 			addr.sin_addr.s_addr = alt_dst;
 		}
 
-		ret = sendto(netPath->eventSock, buf, length, 0, 
-			     (struct sockaddr *)&addr, 
-			     sizeof(struct sockaddr_in));
-		if (ret <= 0)
-			DBG("error sending uni-cast event message\n");
-		/* 
+		ret = sendMessage(netPath->eventSock, buf, length,
+                      (struct sockaddr *)&addr, sizeof(addr),
+                      "unicast event");
+		if (ret == 0) {
+		/*
 		 * Need to forcibly loop back the packet since
-		 * we are not using multicast. 
+		 * we are not using multicast.
 		 */
 		addr.sin_addr.s_addr = htonl(INADDR_LOOPBACK);
 
-		ret = sendto(netPath->eventSock, buf, length, 0, 
-			     (struct sockaddr *)&addr, 
-			     sizeof(struct sockaddr_in));
-		if (ret <= 0)
-			DBG("error looping back uni-cast event message\n");
-		
+		ret = sendMessage(netPath->eventSock, buf, length,
+                        (struct sockaddr *)&addr, sizeof(addr),
+                        "loopback unicast event");
+		}
 	} else {
 		addr.sin_addr.s_addr = netPath->multicastAddr;
+    
+		ret = sendMessage(netPath->eventSock, buf, length,
+                      (struct sockaddr *)&addr, sizeof(addr),
+                      "multicast event");
+	}
 
-		ret = sendto(netPath->eventSock, buf, length, 0, 
-			     (struct sockaddr *)&addr, 
-			     sizeof(struct sockaddr_in));
-		if (ret <= 0)
-			DBG("error sending multi-cast event message\n");
+	if (ret == 0) {
+		if (txTimestamp(ptpClock, (char *)buf, length, rtOpts->time_mode, TRUE) != 0) {
+			ERROR("txTimestamp failed\n");
+			ret = ENOTIMESTAMP;
+		}
 	}
 
 	return ret;
 }
 
-ssize_t 
+int 
 netSendGeneral(Octet * buf, UInteger16 length, NetPath * netPath, Integer32 alt_dst)
 {
-	ssize_t ret;
+	int ret;
 	struct sockaddr_in addr;
 
 	addr.sin_family = AF_INET;
 	addr.sin_port = htons(PTP_GENERAL_PORT);
 
 	if(netPath->unicastAddr || alt_dst ){
-	if (netPath->unicastAddr) {
-		addr.sin_addr.s_addr = netPath->unicastAddr;
+		if (netPath->unicastAddr) {
+			addr.sin_addr.s_addr = netPath->unicastAddr;
 		} else {
 			addr.sin_addr.s_addr = alt_dst;
 		}
-
-
-		ret = sendto(netPath->generalSock, buf, length, 0, 
-			     (struct sockaddr *)&addr, 
-			     sizeof(struct sockaddr_in));
-		if (ret <= 0)
-			DBG("error sending uni-cast general message\n");
+		ret = sendMessage(netPath->eventSock, buf, length,
+                      (struct sockaddr *)&addr, sizeof(addr),
+                      "unicast general");
 	} else {
 		addr.sin_addr.s_addr = netPath->multicastAddr;
+		ret = sendMessage(netPath->generalSock, buf, length,
+                      (struct sockaddr *)&addr, sizeof(addr),
+                      "multicast general");
+	}
 
-		ret = sendto(netPath->generalSock, buf, length, 0, 
-			     (struct sockaddr *)&addr, 
-			     sizeof(struct sockaddr_in));
-		if (ret <= 0)
-			DBG("error sending multi-cast general message\n");
-	}
 	return ret;
 }
 
-ssize_t 
+int 
 netSendPeerGeneral(Octet * buf, UInteger16 length, NetPath * netPath)
 {
 
-	ssize_t ret;
+	int ret;
 	struct sockaddr_in addr;
 
 	addr.sin_family = AF_INET;
@@ -1048,64 +1575,52 @@
 	if (netPath->unicastAddr) {
 		addr.sin_addr.s_addr = netPath->unicastAddr;
 
-		ret = sendto(netPath->generalSock, buf, length, 0, 
-			     (struct sockaddr *)&addr, 
-			     sizeof(struct sockaddr_in));
-		if (ret <= 0)
-			DBG("error sending uni-cast general message\n");
-
+		ret = sendMessage(netPath->eventSock, buf, length,
+                      (struct sockaddr *)&addr, sizeof(addr),
+                      "unicast general");
 	} else {
 		addr.sin_addr.s_addr = netPath->peerMulticastAddr;
 
-		ret = sendto(netPath->generalSock, buf, length, 0, 
-			     (struct sockaddr *)&addr, 
-			     sizeof(struct sockaddr_in));
-		if (ret <= 0)
-			DBG("error sending multi-cast general message\n");
+		ret = sendMessage(netPath->generalSock, buf, length,
+                      (struct sockaddr *)&addr, sizeof(addr),
+                      "multicast general");
 	}
 	return ret;
 
 }
 
-ssize_t 
-netSendPeerEvent(Octet * buf, UInteger16 length, NetPath * netPath)
+int
+netSendPeerEvent(Octet * buf, UInteger16 length, PtpClock * ptpClock, RunTimeOpts * rtOpts)
 {
-	ssize_t ret;
+	int ret;
 	struct sockaddr_in addr;
+	NetPath *netPath = &ptpClock->netPath;
 
 	addr.sin_family = AF_INET;
 	addr.sin_port = htons(PTP_EVENT_PORT);
 
 	if (netPath->unicastAddr) {
 		addr.sin_addr.s_addr = netPath->unicastAddr;
-
-		ret = sendto(netPath->eventSock, buf, length, 0, 
-			     (struct sockaddr *)&addr, 
-			     sizeof(struct sockaddr_in));
-		if (ret <= 0)
-			DBG("error sending uni-cast event message\n");
-
-		/* 
-		 * Need to forcibly loop back the packet since
-		 * we are not using multicast. 
-		 */
-		addr.sin_addr.s_addr = htonl(INADDR_LOOPBACK);
-		
-		ret = sendto(netPath->eventSock, buf, length, 0, 
-			     (struct sockaddr *)&addr, 
-			     sizeof(struct sockaddr_in));
-		if (ret <= 0)
-			DBG("error looping back uni-cast event message\n");			
+		ret = sendMessage(netPath->eventSock, buf, length,
+                      (struct sockaddr *)&addr, sizeof(addr),
+                      "unicast event");
 	} else {
 		addr.sin_addr.s_addr = netPath->peerMulticastAddr;
+		ret = sendMessage(netPath->eventSock, buf, length,
+                      (struct sockaddr *)&addr, sizeof(addr),
+                      "multicast event");
+	}
 
-		ret = sendto(netPath->eventSock, buf, length, 0, 
-			     (struct sockaddr *)&addr, 
-			     sizeof(struct sockaddr_in));
-		if (ret <= 0)
-			DBG("error sending multi-cast event message\n");
-	}
-	return ret;
+  /* @pdelay_req TODO timestamp is not being collected when PDELAY_REQ messages */
+  /* are sent. Collect the timestamp and throw it away for now */
+  if (ret == 0) {
+    if (txTimestamp(ptpClock, buf, length, rtOpts->time_mode, FALSE) != 0) {
+      ERROR("txTimestamp failed\n");
+      ret = ENOTIMESTAMP;
+    }
+  }
+
+  return ret;
 }
 
 
diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/ptpd_dep.h
--- a/src/dep/ptpd_dep.h	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/ptpd_dep.h	Sun Oct 27 22:49:29 2013 -0700
@@ -1,9 +1,39 @@
+/*-
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
+ * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
+ *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
+ * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
+ *
+ * All Rights Reserved
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are
+ * met:
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
+ * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+ * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
+ * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
 /**
  * @file   ptpd_dep.h
- * 
+ *
  * @brief  External definitions for inclusion elsewhere.
- * 
- * 
+ *
+ *
  */
 
 #ifndef PTPD_DEP_H_
@@ -43,12 +73,12 @@
 #define EMERGENCY(x, ...) message(LOG_EMERG, x, ##__VA_ARGS__)
 #define ALERT(x, ...)     message(LOG_ALERT, x, ##__VA_ARGS__)
 #define CRITICAL(x, ...)  message(LOG_CRIT, x, ##__VA_ARGS__)
-#define ERROR(x, ...)  message(LOG_ERR, x, ##__VA_ARGS__)
+#define ERROR(x, ...)     message(LOG_ERR, x, ##__VA_ARGS__)
 #define PERROR(x, ...)    message(LOG_ERR, x "      (strerror: %m)\n", ##__VA_ARGS__)
 #define WARNING(x, ...)   message(LOG_WARNING, x, ##__VA_ARGS__)
-#define NOTIFY(x, ...) message(LOG_NOTICE, x, ##__VA_ARGS__)
+#define NOTIFY(x, ...)    message(LOG_NOTICE, x, ##__VA_ARGS__)
 #define NOTICE(x, ...)    message(LOG_NOTICE, x, ##__VA_ARGS__)
-#define INFO(x, ...)   message(LOG_INFO, x, ##__VA_ARGS__)
+#define INFO(x, ...)      message(LOG_INFO, x, ##__VA_ARGS__)
 
 
 
@@ -90,7 +120,6 @@
 #undef PTPD_DBG2
 #define PTPD_DBG
 #define PTPD_DBG2
-
 #define DBGV(x, ...) message(LOG_DEBUGV, x, ##__VA_ARGS__)
 #else
 #define DBGV(x, ...)
@@ -116,6 +145,12 @@
 #define DBG(x, ...)
 #endif
 
+#ifdef PTPD_DUMP
+#define DUMP(text, addr, len) dump(text, addr, len)
+#else
+#define DUMP(text, addr, len)
+#endif
+
 /** \}*/
 
 /** \name Endian corrections*/
@@ -179,7 +214,7 @@
 void msgUnpackManagement(Octet * buf,MsgManagement*);
 UInteger8 msgUnloadManagement(Octet * buf,MsgManagement*,PtpClock*,RunTimeOpts*);
 void msgUnpackManagementPayload(Octet *buf, MsgManagement *manage);
-void msgPackHeader(Octet * buf,PtpClock*);
+void msgPackHeader(Octet * buf,PtpClock*,unsigned int);
 void msgPackAnnounce(Octet * buf,PtpClock*);
 void msgPackSync(Octet * buf,Timestamp*,PtpClock*);
 void msgPackFollowUp(Octet * buf,Timestamp*,PtpClock*);
@@ -211,13 +246,14 @@
 Boolean netInit(NetPath*,RunTimeOpts*,PtpClock*);
 Boolean netShutdown(NetPath*);
 int netSelect(TimeInternal*,NetPath*);
-ssize_t netRecvEvent(Octet*,TimeInternal*,NetPath*);
-ssize_t netRecvGeneral(Octet*,TimeInternal*,NetPath*);
-ssize_t netSendEvent(Octet*,UInteger16,NetPath*, Integer32 );
-ssize_t netSendGeneral(Octet*,UInteger16,NetPath*, Integer32 );
-ssize_t netSendPeerGeneral(Octet*,UInteger16,NetPath*);
-ssize_t netSendPeerEvent(Octet*,UInteger16,NetPath*);
+ssize_t netRecvEvent(Octet*,TimeInternal*,PtpClock*,RunTimeOpts*,Boolean*);
+ssize_t netRecvGeneral(Octet*,TimeInternal*,PtpClock *, RunTimeOpts *);
 
+/* These functions all return 0 for success or an errno in the case of failure */
+int netSendEvent(Octet*,UInteger16,PtpClock*,RunTimeOpts*,Integer32);
+int netSendGeneral(Octet*,UInteger16,NetPath*,Integer32);
+int netSendPeerGeneral(Octet*,UInteger16,NetPath*);
+int netSendPeerEvent(Octet*,UInteger16,PtpClock*,RunTimeOpts*);
 Boolean netRefreshIGMP(NetPath *, RunTimeOpts *, PtpClock *);
 
 
@@ -234,7 +270,7 @@
   offset_from_master_filter*,RunTimeOpts*,PtpClock*,TimeInternal*);
 void updateClock(RunTimeOpts*,PtpClock*);
 
-void servo_perform_clock_step(RunTimeOpts * rtOpts, PtpClock * ptpClock);
+void servo_perform_clock_step(RunTimeOpts * rtOpts, PtpClock * ptpClock, TimeInternal*);
 
 /** \}*/
 
@@ -267,19 +303,110 @@
 
 
 void message(int priority, const char *format, ...);
+void dump(const char *text, void *addr, int len);
 void displayStats(RunTimeOpts *rtOpts, PtpClock *ptpClock);
 Boolean nanoSleep(TimeInternal*);
-void getTime(TimeInternal*);
-void setTime(TimeInternal*);
 double getRand(void);
-Boolean adjFreq(Integer32);
 
 void recordSync(RunTimeOpts * rtOpts, UInteger16 sequenceId, TimeInternal * time);
+/** \}*/
+
+/** \name time.c (Unix API dependent)
+ * -Timing system API*/
+ /**\{*/
+Boolean initTime(RunTimeOpts*, PtpClock*);
+void shutdownTime(PtpClock*);
+void getTime(TimeInternal*, TimeMode, PtpClock*);
+void setTime(TimeInternal*, TimeMode, PtpClock*);
+void syncSystemWithNIC(RunTimeOpts *rtOpts, PtpClock *ptpClock);
+
+/**
+ * Adjusts the time, ideally by varying the clock rate.
+ *
+ * @param adj      frequency adjustment: a time source which supports that ignores the offset
+ */
+void adjTime(LongDouble adj, TimeMode timeMode, PtpClock*);
+
+/**
+ * Adjusts the time by shifting the clock.
+ *
+ * @param offset   this value must be substracted from clock (might be negative)
+ */
+void adjTimeOffset(TimeInternal *offset, TimeMode timeMode, PtpClock*);
+
+/**
+ * Adjusts the time by shifting the clock to insert a leap second
+ */
+void adjTimeInsertLeapSecond(TimeMode timeMode, RunTimeOpts*, PtpClock*);
+
+/**
+ * Adjusts the time by shifting the clock to delete a leap second
+ */
+void adjTimeDeleteLeapSecond(TimeMode timeMode, RunTimeOpts*, PtpClock*);
+
+/**
+ * Gets the time when the latest outgoing packet left the host.
+ *
+ * There is no way to identify the packet the time stamp belongs to,
+ * so this must be called after sending each packet until the time
+ * stamp for the packet is available. This can be some (hopefully
+ * small) time after the packet was passed to the IP stack.
+ *
+ * There is no mechanism either to determine packet loss and thus a
+ * time stamp which never becomes available.
+ *
+ * @todo Can such packet loss occur?
+ *
+ * Does not work with TIME_SYSTEM.
+ *
+ * @retval sendTimeStamp    set to the time when the packet left the host
+ * @return TRUE if the time stamp was available
+ */
+Boolean getSendTime(TimeInternal *sendTimeStamp, TimeMode, NetPath*);
+
+/**
+ * Gets the time when the packet identified by the given attributes
+ * was received by the host.
+ *
+ * Because the arrival of packets is out of the control of PTPd, the
+ * time stamping must support unique identification of which time
+ * stamp belongs to which packet.
+ *
+ * Due to packet loss in the receive queue, there can be time stamps
+ * without IP packets. getReceiveTime() automatically discards stale
+ * time stamps, including the ones that where returned by
+ * getReceiveTime(). This implies that there is not guarantee that
+ * calling getReceiveTime() more than once for the same packet
+ * will always return a result.
+ *
+ * Due to hardware limitations only one time stamp might be stored
+ * until queried by the NIC driver; this can lead to packets without
+ * time stamp. This needs to be handled by the caller of
+ * getReceiveTime(), for example by ignoring the packet.
+ *
+ * Does not work with TIME_SYSTEM.
+ *
+ * @retval recvTimeStamp    set to the time when the packet entered the host, if available
+ * @return TRUE if the time stamp was available
+ */
+Boolean getReceiveTime(TimeInternal *recvTimeStamp,
+                       ClockIdentity clockIdentity,
+                       UInteger16 sequenceId, TimeMode, NetPath*);
+
+long get_current_tickrate(void);
+
 
 #if defined(__APPLE__)
 void 	adjTime(Integer32);
 #endif /* __APPLE__ */
 
+#if !defined(__APPLE__)
+void setTimexFlags(int flags, Boolean quiet);
+void unsetTimexFlags(int flags, Boolean quiet);
+int getTimexFlags(void);
+Boolean checkTimexFlags(int flags);
+#endif /* apple */
+
 /** \}*/
 
 /** \name timer.c (Unix API dependent)
@@ -297,6 +424,9 @@
 void timerStart_random(UInteger16 index, float interval, IntervalTimer * itimer);
 
 Boolean timerExpired(UInteger16,IntervalTimer*);
+
+/** gets the current system time */
+void timerNow(TimeInternal*);
 /** \}*/
 
 
